> ## Documentation Index
> Fetch the complete documentation index at: https://docs.trugen.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Tool

> Updates an existing client-side tool using its unique ID.



## OpenAPI

````yaml PUT /ext/tool/{id}
openapi: 3.0.3
info:
  title: TruGen Developer Platform API
  version: 1.0.0
  description: OpenAPI specification for MCP endpoint
servers:
  - url: https://api.trugen.ai/v1
security: []
paths:
  /ext/tool/{id}:
    put:
      summary: Update Tool details
      description: Updates an existing client-side tool using its unique ID.
      operationId: updateToolById
      parameters:
        - name: id
          in: path
          required: true
          description: The UUID of the tool to update
          schema:
            type: string
            format: uuid
            example: 611eaabb-0884-440f-a4f1-a04b9ad8a597
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                type:
                  type: string
                  example: tool.client
                schema:
                  type: object
                  description: Client-side function schema
                  properties:
                    type:
                      type: string
                      example: function
                    name:
                      type: string
                      example: start_cloud_browser_session1
                    description:
                      type: string
                      example: Starts the dashboard page with logged in session1.
                    parameters:
                      type: object
                      properties:
                        type:
                          type: string
                          example: object
                        properties:
                          type: object
                          additionalProperties:
                            type: object
                            properties:
                              type:
                                type: string
                              description:
                                type: string
                        required:
                          type: array
                          items:
                            type: string
                  required:
                    - type
                    - name
                    - parameters
                request_config:
                  type: object
                  properties:
                    method:
                      type: string
                      example: GET
                    url:
                      type: string
                      example: https://www.example.com/information
                    headers:
                      type: object
                      additionalProperties:
                        type: string
                      example:
                        User-Agent: Trugen Avatar
                        Accept: application/json
                event_messages:
                  type: object
                  properties:
                    on_start:
                      type: object
                      properties:
                        message:
                          type: string
                    on_success:
                      type: object
                      properties:
                        message:
                          type: string
                    on_delay:
                      type: object
                      properties:
                        delay:
                          type: integer
                        message:
                          type: string
                    on_error:
                      type: object
                      properties:
                        message:
                          type: string
              required:
                - type
                - schema
                - request_config
                - event_messages
            example:
              type: tool.client
              schema:
                type: function
                name: start_cloud_browser_session1
                description: Starts the dashboard page with logged in session1.
                parameters:
                  type: object
                  properties:
                    url:
                      type: string
                      description: URL to navigate to
                  required:
                    - url
              request_config:
                method: GET
                url: https://www.example.com/information
                headers:
                  User-Agent: Trugen Avatar
                  Accept: application/json
              event_messages:
                on_start:
                  message: Getting stock price data...
                on_success:
                  message: Successfully received data.
                on_delay:
                  delay: 1
                  message: Waiting for stock price data...
                on_error:
                  message: Failed to retrieve stock price data
      responses:
        '200':
          description: Tool details updated successfully
        '400':
          description: Invalid input data
        '401':
          description: Unauthorized
        '404':
          description: Tool not found
        '500':
          description: Internal server error
      security:
        - apiKeyAuth: []
components:
  securitySchemes:
    apiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key

````